#!/usr/bin/perl
#
#  This is licensed under the GPL.
#
#  nslisten.pl 1.2.0  :  19 September 1999
#
#  Send netscape to this script for
#  on-the-click mp3 streaming via
#  shoutcast or icecast server!! :)
#  
#  Uses: tcl    (8.0)    --> http://www.scriptics.com/
#        perl   (5)      --> http://www.perl.com/
#        mpg123 (0.59k)  --> http://www-ti.informatik.uni-tuebingen.de/~hippm/mpg123.html
#
#  ChangeLog: Modified to use gtmpg.tcl gui skin by Mark Anacker. 
#             Better URL handling via regex. No need for IP style 
#             address or port, no difference between handling icecast 
#             or shoutcast broadcasts. This should proove more robust
#             in the field.
#
#  jeremy@theory.org
#
#  SETUP:
#  -----
#  In netscape v4, under Preferences > Applications,
#  create a new type:
#
#               Description: MP3 Shout (or whatever)
#                  MIMEType: audio/x-scpls
#                  Suffixes: pls
#                Handled By: Application
#               Application: /path_to_file/nslisten.pl %u
#     	
#  Make sure that the nslisten.pl file is set executable, and that the #! at
#  the top of the file is pointing to the residence of your perl executable.
#
#  Configure the listen directory and mpg123 options below.
#
#  Check out: http://yp.shoutcast.com/index.html for a list of servers.

use strict;

# mpg123 options
my $mpg123opts = "-k 40 -b 2000";

# grab the url sent by netscape (%u)
my $url = shift;

# following if/elsif's grab the address/port
my ($ip, $port);
if ( ($url =~ /(server=)/i) || ($url =~ /(addr=)/i) ) {
  if ($url  =~ /$1(.+?):(\d+)/i) {
    $ip   = $1;
    $port = $2;
  }
  # if no port is given, assume port 8000
  else {
    $url  =~ /$1.+/i;
    $ip   = $1;
    $port = 8000;
  }
}
else {
  system "echo nslisten: Could not identify broadcast.";
  exit(0);
}

# put together the command to execute
# assumes tkpmg.tcl is somewhere in the path
my $command = "tkmpg.tcl http://$ip:$port";

# print what you are about to execute (as a reference)
# system "echo nslisten: '$command'";

system "$command";

